(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10240,        268]
NotebookOptionsPosition[      9694,        247]
NotebookOutlinePosition[     10226,        266]
CellTagsIndexPosition[     10183,        263]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "\"\<Global`*\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rll", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"rooo", "=", 
     RowBox[{"RotationTransform", "[", 
      RowBox[{"Pi", "/", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"vww", "=", 
     RowBox[{"rooo", "[", 
      RowBox[{"bbb", "-", "aaa"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"len", "=", 
     RowBox[{"Norm", "[", 
      RowBox[{"bbb", "-", "aaa"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ppr", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "+", 
         RowBox[{"(", 
          RowBox[{"tt", "*", 
           RowBox[{"(", 
            RowBox[{"length", "/", "len"}], ")"}], "*", 
           RowBox[{"(", 
            RowBox[{"bbb", "-", "aaa"}], ")"}]}], ")"}]}], "&"}], ",", 
       "rll"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pps", "=", 
     RowBox[{"If", "[", 
      RowBox[{"reflect", ",", 
       RowBox[{"GeometricTransformation", "[", 
        RowBox[{
         RowBox[{"Polygon", "[", "ppr", "]"}], ",", 
         RowBox[{"ReflectionTransform", "[", 
          RowBox[{"vww", ",", "bbb"}], "]"}]}], "]"}], ",", 
       RowBox[{"Polygon", "[", "ppr", "]"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Graphics", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"Polygon", "[", "rll", "]"}], ",", "Blue", ",", "pps", ",", 
        "\[IndentingNewLine]", "Purple", ",", "\[IndentingNewLine]", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{"aaa", ",", "bbb"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", "Red", ",", "\[IndentingNewLine]", 
        RowBox[{"Arrow", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"length", "/", "len"}], ")"}], "*", 
             RowBox[{"(", 
              RowBox[{"bbb", "-", "aaa"}], ")"}]}]}]}], "}"}], "]"}]}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Axes", "\[Rule]", "True"}], ","}], "*)"}], " ", 
      "\[IndentingNewLine]", 
      RowBox[{"Frame", "\[Rule]", "True"}]}], "\[IndentingNewLine]", "]"}]}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"reflect", ",", 
     RowBox[{"{", 
      RowBox[{"False", ",", "True"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"aaa", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "8"}], ",", "0"}], "}"}]}], "}"}], ",", "Locator"}], 
    "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bbb", ",", 
       RowBox[{"{", 
        RowBox[{"8", ",", "0"}], "}"}]}], "}"}], ",", "Locator"}], "}"}], ",",
    "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"length", ",", "0", ",", "len"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"tt", ",", "0", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{
  3.60436548247003*^9, {3.604365629703677*^9, 3.6043656403063087`*^9}, {
   3.604365688782645*^9, 3.604365715259153*^9}, {3.604365864765438*^9, 
   3.604365988681134*^9}, {3.60436604812285*^9, 3.6043660833504953`*^9}, {
   3.604366141093383*^9, 3.604366141972959*^9}, {3.6043662160178423`*^9, 
   3.604366232178692*^9}, {3.6044039926642723`*^9, 3.6044040660521927`*^9}, {
   3.604404116166754*^9, 3.604404119882885*^9}, {3.604404257081738*^9, 
   3.60440426900778*^9}, {3.6044043853800898`*^9, 3.604404386364501*^9}, {
   3.6044053920389347`*^9, 3.6044053926860647`*^9}, {3.6044054419523*^9, 
   3.604405457870388*^9}, 3.6044055239482613`*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`aaa$$ = {-8, 0}, $CellContext`bbb$$ = {8, 
    0}, $CellContext`length$$ = 0, $CellContext`reflect$$ = 
    False, $CellContext`tt$$ = 0, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`reflect$$], {False, True}}, {{
       Hold[$CellContext`aaa$$], {-8, 0}}, Automatic}, {{
       Hold[$CellContext`bbb$$], {8, 0}}, Automatic}, {
      Hold[$CellContext`length$$], 0, 16}, {
      Hold[$CellContext`tt$$], 0, 1}}, Typeset`size$$ = {505., {243., 253.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`reflect$70105$$ = False, $CellContext`length$70106$$ = 
    0, $CellContext`tt$70107$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`aaa$$ = {-8, 0}, $CellContext`bbb$$ = {8, 
         0}, $CellContext`length$$ = 0, $CellContext`reflect$$ = 
        False, $CellContext`tt$$ = 0}, "ControllerVariables" :> {
        Hold[$CellContext`reflect$$, $CellContext`reflect$70105$$, False], 
        Hold[$CellContext`length$$, $CellContext`length$70106$$, 0], 
        Hold[$CellContext`tt$$, $CellContext`tt$70107$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> ($CellContext`rooo = 
        RotationTransform[
         Pi/2]; $CellContext`vww = $CellContext`rooo[$CellContext`bbb$$ - \
$CellContext`aaa$$]; $CellContext`len = 
        Norm[$CellContext`bbb$$ - $CellContext`aaa$$]; $CellContext`ppr = 
        Map[# + $CellContext`tt$$ ($CellContext`length$$/$CellContext`len) \
($CellContext`bbb$$ - $CellContext`aaa$$)& , $CellContext`rll]; \
$CellContext`pps = If[$CellContext`reflect$$, 
          GeometricTransformation[
           Polygon[$CellContext`ppr], 
           ReflectionTransform[$CellContext`vww, $CellContext`bbb$$]], 
          Polygon[$CellContext`ppr]]; Graphics[{Green, 
          Polygon[$CellContext`rll], Blue, $CellContext`pps, Purple, 
          Line[{$CellContext`aaa$$, $CellContext`bbb$$}], Red, 
          
          Arrow[{{0, 
            0}, {0, 0} + ($CellContext`length$$/$CellContext`len) \
($CellContext`bbb$$ - $CellContext`aaa$$)}]}, 
         PlotRange -> {{-10, 10}, {-10, 10}}, Frame -> True]), 
      "Specifications" :> {{$CellContext`reflect$$, {
         False, True}}, {{$CellContext`aaa$$, {-8, 0}}, Automatic, 
         ControlType -> Locator}, {{$CellContext`bbb$$, {8, 0}}, Automatic, 
         ControlType -> Locator}, {$CellContext`length$$, 
         0, $CellContext`len}, {$CellContext`tt$$, 0, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{579., {350., 358.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.604404848453672*^9, 3.604404976220969*^9, 3.604405396549232*^9, 
   3.604405461720481*^9, {3.604405549857361*^9, 3.604405574451254*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"THIS", " ", "NOTEBOOK", " ", 
  "IS"}], "\n", "\"\<Bard - Mathematica - Glide Reflection Demo\>\"", "\
\[IndentingNewLine]", 
 RowBox[{"By", " ", 
  ButtonBox[
   RowBox[{"Ethan", " ", "Bloch"}],
   BaseStyle->"Hyperlink",
   ButtonData->{
     URL["http://demonstrations.wolfram.com/author.html?author=Jim+Brandt"], 
     None},
   ButtonNote->
    "http://demonstrations.wolfram.com/author.html?author=Jim+Brandt"]}]}], \
"Input",
 CellChangeTimes->{{3.604405357298624*^9, 3.6044053610410557`*^9}}]
},
WindowSize->{740, 867},
WindowMargins->{{Automatic, 249}, {Automatic, 0}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> True}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 5037, 137, 616, "Input"],
Cell[5619, 161, 3531, 67, 766, "Output"]
}, Open  ]],
Cell[9165, 231, 525, 14, 90, "Input"]
}
]
*)

(* End of internal cache information *)
